Global h$
Global t$
Global en.l

Enumeration
  #opt_script
  #opt_sect
  #opt_body
EndEnumeration

Procedure detag(bt$,et$,flg.l)
  p1.l=1
  Repeat
    p1=FindString(h$,bt$,p1,#PB_String_NoCase)
    If p1
      p2.l=FindString(h$,et$,p1,#PB_String_NoCase)
      If p2
        h$=Mid( h$,1,p1-1 )+Mid( h$,p2+Len(et$) )
        ;         If flg
        ;           h$=Mid( h$,1,p1+Len(bt$))+Mid( h$,p2)
        ;           Break
        ;         Else
        ;           h$=Mid( h$,1,p1 )+Mid( h$,p2+Len(et$) )
        ;         EndIf
      Else
        Break
      EndIf
    EndIf
  Until p1=0
EndProcedure


Procedure Tip(iWindowID.i, iGadget.i, sTip.s)
  ;--------------------------------------------
  iToolTip = CreateWindowEx_(0,"ToolTips_Class32","",#WS_POPUP | #TTS_NOPREFIX,0,0,0,0,iWindowID,0,GetModuleHandle_(0),0)
  SendMessage_(iToolTip,#TTM_SETTIPTEXTCOLOR,GetSysColor_(#COLOR_INFOTEXT),0)
  SendMessage_(iToolTip,#TTM_SETTIPBKCOLOR,GetSysColor_(#COLOR_INFOBK),0)
  SendMessage_(iToolTip,#TTM_SETMAXTIPWIDTH,0,200)
  Tip.TOOLINFO\cbSize=SizeOf(TOOLINFO)
  Tip\uFlags = #TTF_IDISHWND | #TTF_SUBCLASS
  Tip\hwnd = WindowID(0)
  Tip\uId = WindowID(0);GadgetID(iGadget)
  Tip\lpszText = @sTip
  SendMessage_(iToolTip, #TTM_ADDTOOL, 0, @Tip)
EndProcedure

Procedure unhtml(f$)
  ;  f$="1.html"
  en=#PB_UTF8
  If ReadFile(0,f$)
    ff.l=FileSize(f$)
    *m=AllocateMemory(ff)
    ReadData(0,*m,ff)
    CloseFile(0)
    
    h$=PeekS(*m,ff,#PB_UTF8)
    p.l=FindString(h$,"charset=",1,#PB_String_NoCase)
    If p
      p$=Mid(h$,p,20)
      p$=ReplaceString(p$,Chr(34),"")
      p$=ReplaceString(p$,"'","")

;      p=FindString(h$,"utf-8",p,#PB_String_NoCase)
;      If p=0
;      Debug Mid(p$,9,5)
      If LCase(Mid(p$,9,5))<>"utf-8"
        en=#PB_Ascii
        h$=PeekS(*m,ff,#PB_Ascii)
        MessageRequester("Encoding", "Possible not UTF-8")
      EndIf
    EndIf
    FreeMemory(*m)
    
    If GetGadgetState(#opt_script)
      detag("<script","</script>",0)
    EndIf
    If GetGadgetState(#opt_sect)
      detag("<section","</section>",0)
    EndIf
    If GetGadgetState(#opt_body)
      detag("</body>","</html>",1)
      h$=h$+#CRLF$+"</body>"+#CRLF$+"</html>"
    EndIf
    
    s$=GetPathPart(f$)
    t$=s$
    ; Debug s$
    ; Debug Mid(f$,Len(s$)+1)
    s$=s$+"~"+Mid(f$,Len(s$)+1)
    ;CreateFile(0,"2.html")
    If CreateFile( 0,s$)
      WriteString(0,h$,en);#PB_UTF8)
      CloseFile(0)
    Else
      MessageRequester("Oops","Error write"+#CRLF$+s$)
      ;  End
    EndIf
    
  Else
    MessageRequester("Oops","Error read"+#CRLF$+f$)
    ;  End
  EndIf
  
EndProcedure

If OpenWindow(0, 0, 0, 200, 200, "un-HTML 0.8", #PB_Window_SystemMenu | #PB_Window_ScreenCentered| #PB_Window_MinimizeGadget)
  CheckBoxGadget(#opt_script, 0,  0, 250, 20, "script")
  CheckBoxGadget(#opt_sect, 0,  20, 250, 20, "section")
  CheckBoxGadget(#opt_body, 0,  40, 250, 20, "body")
  
  If ReadFile(0,"unhtml.cfg")
    SetGadgetState(#opt_script,ReadLong(0))
    SetGadgetState(#opt_sect,ReadLong(0))
    SetGadgetState(#opt_body,ReadLong(0))
    CloseFile(0)
  EndIf
  
  t$=GetCurrentDirectory()
  
  ;StickyWindow(0,1)
  Tip(0, 0, "Drag'n'Drop or click to load")
  EnableWindowDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
  
  If CountProgramParameters()
    unhtml(ProgramParameter(0))
  EndIf
  
  Repeat
    ev=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&$8000
      Break
    EndIf
    Select ev
      Case #PB_Event_LeftClick 
        Pattern$ = "HTML (*.htm)|*.htm;*.html"
        File$ = OpenFileRequester("Please choose file to load", t$, Pattern$, 0)
        If File$
          unhtml(File$)
        EndIf
        
      Case #PB_Event_WindowDrop
        Files$ = EventDropFiles()
        Count  = CountString(Files$, Chr(10)) + 1
        For i = 1 To Count
          unhtml ( StringField( Files$,i,Chr(10) ) )
        Next i
        
    EndSelect
  Until ev = #PB_Event_CloseWindow
EndIf

If CreateFile(0,"unhtml.cfg")
  WriteLong(0,GetGadgetState(#opt_script))
  WriteLong(0,GetGadgetState(#opt_sect))
  WriteLong(0,GetGadgetState(#opt_body))
  CloseFile(0)
EndIf
;End

; f$="1.html"
; If ReadFile(0,f$)
;   ff.l=FileSize(f$)
;   *m=AllocateMemory(ff)
;   ReadData(0,*m,ff)
;   CloseFile(0)
; Else
;   Debug "oops"
;   End
; EndIf
; 
; h$=PeekS(*m,ff,#PB_UTF8)
; 
; detag("<script","</script>",0)
; 
; detag("<section","</section>",0)
; detag("</body>","</html>",1)
; h$=h$+#CRLF$+"</body>"+#CRLF$+"</html>"
; ; Repeat
; ; p1.l=FindString(h$,"<section")
; ; If p1
; ;   ;  Debug Mid(h$,1,p1)
; ;   p2.l=FindString(h$,"</section>",p1)
; ;   If p2
; ;     ;Debug Mid(h$,p2+10)
; ;     h$=Mid(h$,1,p1)+Mid(h$,p2+10)
; ;   Else
; ;     Break
; ;   EndIf
; ; EndIf
; ; 
; ; Until p1=0
; 
; CreateFile(0,"2.html")
; WriteString(0,h$,#PB_UTF8)
; CloseFile(0)

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 64
; FirstLine = 51
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = unhtml.ico
; Executable = unhtml.exe